"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ToolbarView = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importStar(require("react"));
const react_use_1 = require("react-use");
const menubar_1 = require("../i18n/menubar");
const useSticky_1 = require("../react-utils/useSticky");
const toolbar_1 = require("../toolbar");
const sticky_1 = require("./sticky");
function ToolbarView({ editor, editorMode, toolbarEditor, toolbarFocus, toolbarConfig, hiddenActionsConfig, settingsVisible, className, children, stickyToolbar, }) {
    const rerender = (0, react_use_1.useUpdate)();
    (0, react_1.useLayoutEffect)(() => {
        editor.on('rerender-toolbar', rerender);
        return () => {
            editor.off('rerender-toolbar', rerender);
        };
    }, [editor, rerender]);
    const wrapperRef = (0, react_1.useRef)(null);
    const isStickyActive = (0, useSticky_1.useSticky)(wrapperRef) && stickyToolbar;
    return (react_1.default.createElement("div", { ref: wrapperRef, className: sticky_1.stickyCn.toolbar({
            withSettings: settingsVisible,
            stickyActive: isStickyActive,
            isSticky: stickyToolbar,
        }, [className]) },
        react_1.default.createElement(toolbar_1.FlexToolbar, { data: toolbarConfig, hiddenActions: hiddenActionsConfig, editor: toolbarEditor, focus: toolbarFocus, dotsTitle: (0, menubar_1.i18n)('more_action'), onClick: (id, attrs) => editor.emit('toolbar-action', { id, attrs, editorMode }) }),
        children));
}
exports.ToolbarView = ToolbarView;
