import { ActionStorage } from 'src/core';
import type { SelectionContextConfig, SelectionContextItemData } from '../../extensions/behavior/SelectionContext';
import { ToolbarData } from '../../toolbar/Toolbar';
import { ToolbarGroupData } from '../../toolbar/ToolbarGroup';
import { ToolbarListButtonData } from '../../toolbar/ToolbarListButton';
import { ToolbarGroupItemData, ToolbarItemData, ToolbarListButtonItemData, ToolbarListItemData, ToolbarSingleItemData } from '../../toolbar/types';
import type { MarkdownEditorPreset } from '../types';
export declare type WToolbarData = ToolbarData<ActionStorage>;
export declare type WToolbarItemData = ToolbarItemData<ActionStorage>;
export declare type WToolbarSingleItemData = ToolbarSingleItemData<ActionStorage>;
export declare type WToolbarGroupData = ToolbarGroupData<ActionStorage>;
export declare type WToolbarGroupItemData = ToolbarGroupItemData<ActionStorage>;
export declare type WToolbarListButtonData = ToolbarListButtonData<ActionStorage>;
export declare type WToolbarListItemData = ToolbarListItemData<ActionStorage>;
export declare type WToolbarListButtonItemData = ToolbarListButtonItemData<ActionStorage>;
export declare const wHistoryGroupConfig: WToolbarGroupData;
/** Bold, Italic, Underline, Strike buttons group */
export declare const wBoldItemData: WToolbarSingleItemData;
export declare const wItalicItemData: WToolbarSingleItemData;
export declare const wUnderlineItemData: WToolbarSingleItemData;
export declare const wStrikethroughItemData: WToolbarSingleItemData;
export declare const wMonospaceItemData: WToolbarSingleItemData;
export declare const wMarkedItemData: WToolbarSingleItemData;
export declare const wBiusGroupConfig: WToolbarGroupData;
export declare const wTextItemData: WToolbarListButtonItemData;
export declare const wHeadingListConfig: WToolbarListButtonData;
export declare const wListsListConfig: WToolbarListButtonData;
export declare const wCheckboxItemData: WToolbarSingleItemData;
export declare const wLinkItemData: WToolbarSingleItemData;
export declare const wQuoteItemData: WToolbarSingleItemData;
export declare const wCutItemData: WToolbarSingleItemData;
export declare const wListMoveListConfig: WToolbarListButtonData;
export declare const wNoteItemData: WToolbarSingleItemData;
export declare const wTableItemData: WToolbarSingleItemData;
export declare const wCodeItemData: WToolbarSingleItemData;
export declare const wCodeBlockItemData: WToolbarItemData;
export declare const wCodeListConfig: WToolbarListButtonData;
export declare const wImageItemData: WToolbarSingleItemData;
export declare const wHruleItemData: WToolbarItemData;
export declare const wEmojiItemData: WToolbarItemData;
export declare const wFileItemData: WToolbarSingleItemData;
export declare const wMathInlineItemData: WToolbarSingleItemData;
export declare const wTabsItemData: WToolbarSingleItemData;
export declare const wMathBlockItemData: WToolbarSingleItemData;
export declare const wMathListConfig: WToolbarListButtonData;
export declare const wMathListItem: WToolbarListItemData;
export declare const wYfmHtmlBlockItemData: WToolbarSingleItemData;
export declare const wGptItemData: WToolbarSingleItemData;
export declare const wCommandMenuConfig: WToolbarItemData[];
export declare const wHiddenData: WToolbarItemData[];
/** prepared wysiwyg toolbar config */
export declare const wToolbarConfig: WToolbarData;
export declare const wToggleHeadingFoldingItemData: SelectionContextItemData;
export declare const wSelectionMenuConfig: SelectionContextConfig;
export declare const wMermaidItemData: WToolbarSingleItemData;
export declare const wToolbarConfigByPreset: Record<MarkdownEditorPreset, WToolbarData>;
export declare const wCommandMenuConfigByPreset: Record<MarkdownEditorPreset, WToolbarItemData[]>;
export declare const wHiddenDataByPreset: Record<MarkdownEditorPreset, WToolbarItemData[]>;
export declare const wSelectionMenuConfigByPreset: Record<MarkdownEditorPreset, SelectionContextConfig>;
