"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IconRefuge = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const uikit_1 = require("@gravity-ui/uikit");
const IconRefuge_classname_1 = require("./IconRefuge.classname");
/**
 * Creates a div wrapper above the icon, which sets the min-width and min-height
 * equal to its refugeSize prop, puts the original icon in the middle and
 * proxies the rest of the propses to it.
 *
 * The component is made in order to add margins to icons that have
 * margins are indented, but their svg exactly wrap around the edges of the image
 *
 * It seems that all icons will be square, if not, then you can simply add
 * refugeWidth and refugeHeight
 */
const IconRefuge = (_a) => {
    var { refugeSize, containerClassName, containerStyle, widthOnly, inlineIcon, title, 'aria-label': ariaLabel } = _a, props = tslib_1.__rest(_a, ["refugeSize", "containerClassName", "containerStyle", "widthOnly", "inlineIcon", "title", 'aria-label']);
    if (props.size === refugeSize && !title && !ariaLabel && !containerStyle) {
        return react_1.default.createElement(uikit_1.Icon, Object.assign({}, props));
    }
    return (react_1.default.createElement("div", { className: (0, IconRefuge_classname_1.cnIconRefuge)({ inline: inlineIcon }, containerClassName), title: title, "aria-label": ariaLabel, style: Object.assign({ minWidth: refugeSize, minHeight: widthOnly ? undefined : refugeSize }, containerStyle) },
        react_1.default.createElement(uikit_1.Icon, Object.assign({ size: refugeSize }, props))));
};
exports.IconRefuge = IconRefuge;
exports.IconRefuge.displayName = 'Icon';
