"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PresetList = exports.cnGptDialogPresetList = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const uikit_1 = require("@gravity-ui/uikit");
const classname_1 = require("../../../../classname");
const dialog_1 = require("../../../../i18n/gpt/dialog");
const constants_1 = require("../constants");
const useGptHotKeys_1 = require("../hooks/useGptHotKeys");
const usePresetList_1 = require("../hooks/usePresetList");
exports.cnGptDialogPresetList = (0, classname_1.cn)('gpt-dialog-preset-list');
const PresetItem = ({ preset, onPresetClick, disablePromptPresets, hotKey, }) => {
    (0, useGptHotKeys_1.useGptHotKeys)(hotKey, () => {
        onPresetClick(preset.data);
    }, { enableOnFormTags: true, enableOnContentEditable: true });
    return (react_1.default.createElement(uikit_1.ActionTooltip, { title: preset.display, hotkey: hotKey },
        react_1.default.createElement(uikit_1.Button, { className: (0, exports.cnGptDialogPresetList)('preset'), view: "normal", size: "m", disabled: disablePromptPresets, onClick: () => onPresetClick(preset.data) }, preset.display)));
};
const PresetList = ({ disablePromptPresets, promptPresets, onPresetClick, }) => {
    const { presetsContainerRef, visiblePresets, hiddenPresets, showMoreButton, measured } = (0, usePresetList_1.usePresetList)({
        promptPresets,
        onPresetClick,
    });
    return (react_1.default.createElement("div", { className: (0, exports.cnGptDialogPresetList)({ measured }), ref: presetsContainerRef },
        visiblePresets.map((preset, index) => (react_1.default.createElement(PresetItem, { preset: preset, key: preset.display, hotKey: preset.hotKey || constants_1.gptHotKeys.presetsKey(String(index + 1)), disablePromptPresets: disablePromptPresets, onPresetClick: onPresetClick }))),
        showMoreButton && (react_1.default.createElement(uikit_1.DropdownMenu, { switcherWrapperClassName: (0, exports.cnGptDialogPresetList)('more-button-wrapper'), switcher: react_1.default.createElement(uikit_1.Button, { className: (0, exports.cnGptDialogPresetList)('more-button'), view: "normal", size: "m" }, (0, dialog_1.i18n)('more')), items: hiddenPresets }))));
};
exports.PresetList = PresetList;
