import { ExtensionAuto, ExtensionDeps } from '../../../core';
import type { AutocompleteItem } from './types';
export { openAutocomplete, closeAutocomplete } from 'prosemirror-autocomplete';
export declare const AutocompleteDecoClassName = "autocomplete";
export declare type AutocompleteItemFn = (deps: ExtensionDeps) => AutocompleteItem;
export * from './types';
declare type Storage = {
    add(item: AutocompleteItem | AutocompleteItemFn): Storage;
};
/**
 * This extension is wrapper of _prosemirror-autocomplete_
 * You only need to use it once.
 * Don't add this extension many times with different options.
 * Don't import anything from the _prosemirror-autocomplete_ source package.
 * Everything you need is exported from this module.
 */
export declare const Autocomplete: ExtensionAuto;
declare global {
    namespace WysiwygEditor {
        interface Context {
            autocomplete: Storage;
        }
    }
}
