"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isInsideInlineCode = exports.isInsideBlockCode = exports.isInsideCode = void 0;
const isCodeMark = (mark) => mark.type.spec.code;
function isInsideCode(state) {
    if (isInsideBlockCode(state))
        return 'block';
    if (isInsideInlineCode(state))
        return 'inline';
    return false;
}
exports.isInsideCode = isInsideCode;
function isInsideBlockCode(state) {
    // it is enough to check only $from
    // when pasting, the content is inserted into a block with the type from $from
    return Boolean(state.selection.$from.parent.type.spec.code);
}
exports.isInsideBlockCode = isInsideBlockCode;
function isInsideInlineCode(state) {
    var _a;
    // same as for block code
    const fromHasCodeMark = state.selection.$from.marks().some(isCodeMark);
    if (state.selection.empty) {
        return fromHasCodeMark || ((_a = state.storedMarks) !== null && _a !== void 0 ? _a : []).some(isCodeMark);
    }
    return fromHasCodeMark;
}
exports.isInsideInlineCode = isInsideInlineCode;
