"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MarkSpecs = exports.markMarkType = exports.markMarkName = void 0;
const tslib_1 = require("tslib");
const markdown_it_mark_1 = tslib_1.__importDefault(require("markdown-it-mark"));
const schema_1 = require("../../../../utils/schema");
exports.markMarkName = 'mark';
exports.markMarkType = (0, schema_1.markTypeFactory)(exports.markMarkName);
const MarkSpecs = (builder) => {
    builder
        .configureMd((md) => md.use(markdown_it_mark_1.default))
        .addMark(exports.markMarkName, () => ({
        spec: {
            parseDOM: [{ tag: 'mark' }],
            toDOM() {
                return ['mark'];
            },
        },
        fromMd: {
            tokenSpec: {
                name: exports.markMarkName,
                type: 'mark',
            },
        },
        toMd: {
            open: '==',
            close: '==',
            mixable: true,
            expelEnclosingWhitespace: true,
        },
    }));
};
exports.MarkSpecs = MarkSpecs;
