"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Underline = exports.underline = exports.underlineType = exports.underlineMarkName = void 0;
const prosemirror_commands_1 = require("prosemirror-commands");
const actions_1 = require("../../../utils/actions");
const inputrules_1 = require("../../../utils/inputrules");
const keymap_1 = require("../../../utils/keymap");
const UnderlineSpecs_1 = require("./UnderlineSpecs");
var UnderlineSpecs_2 = require("./UnderlineSpecs");
Object.defineProperty(exports, "underlineMarkName", { enumerable: true, get: function () { return UnderlineSpecs_2.underlineMarkName; } });
Object.defineProperty(exports, "underlineType", { enumerable: true, get: function () { return UnderlineSpecs_2.underlineType; } });
/** @deprecated Use `underlineMarkName` instead */
exports.underline = UnderlineSpecs_1.underlineMarkName;
const undAction = 'underline';
const Underline = (builder, opts) => {
    builder.use(UnderlineSpecs_1.UnderlineSpecs);
    builder
        .addAction(undAction, ({ schema }) => (0, actions_1.createToggleMarkAction)((0, UnderlineSpecs_1.underlineType)(schema)))
        .addInputRules(({ schema }) => ({
        rules: [
            (0, inputrules_1.markInputRule)({ open: '++', close: '++', ignoreBetween: '+' }, (0, UnderlineSpecs_1.underlineType)(schema)),
        ],
    }));
    if (opts === null || opts === void 0 ? void 0 : opts.underlineKey) {
        const { underlineKey } = opts;
        builder.addKeymap(({ schema }) => ({
            [underlineKey]: (0, keymap_1.withLogAction)('underline', (0, prosemirror_commands_1.toggleMark)((0, UnderlineSpecs_1.underlineType)(schema))),
        }));
    }
};
exports.Underline = Underline;
