"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getSchemaSpecs = void 0;
const const_1 = require("../const");
const DEFAULT_LABEL_PLACEHOLDER = 'Checkbox';
const getSchemaSpecs = (opts, placeholder) => {
    var _a, _b;
    return ({
        [const_1.CheckboxNode.Checkbox]: {
            group: 'block',
            content: `${const_1.CheckboxNode.Input} ${const_1.CheckboxNode.Label}`,
            selectable: true,
            allowSelection: false,
            parseDOM: [],
            attrs: {
                class: { default: (0, const_1.b)() },
            },
            toDOM(node) {
                return ['div', node.attrs, 0];
            },
            complex: 'root',
        },
        [const_1.CheckboxNode.Input]: {
            group: 'block',
            parseDOM: [],
            attrs: {
                type: { default: 'checkbox' },
                id: { default: null },
                checked: { default: null },
            },
            toDOM(node) {
                return ['div', node.attrs];
            },
            selectable: false,
            allowSelection: false,
            complex: 'leaf',
        },
        [const_1.CheckboxNode.Label]: {
            content: 'inline*',
            group: 'block',
            parseDOM: [
                {
                    tag: `span[class="${(0, const_1.b)('label')}"]`,
                    getAttrs: (node) => ({
                        for: node.getAttribute('for') || '',
                    }),
                },
            ],
            attrs: {
                for: { default: null },
            },
            escapeText: false,
            placeholder: {
                content: (_b = (_a = placeholder === null || placeholder === void 0 ? void 0 : placeholder[const_1.CheckboxNode.Label]) !== null && _a !== void 0 ? _a : opts === null || opts === void 0 ? void 0 : opts.checkboxLabelPlaceholder) !== null && _b !== void 0 ? _b : DEFAULT_LABEL_PLACEHOLDER,
                alwaysVisible: true,
            },
            toDOM(node) {
                return ['span', Object.assign(Object.assign({}, node.attrs), { class: (0, const_1.b)('label') }), 0];
            },
            selectable: false,
            allowSelection: false,
            disableGapCursor: true,
            complex: 'leaf',
        },
    });
};
exports.getSchemaSpecs = getSchemaSpecs;
