import type { Action, ExtensionAuto } from '../../../core';
import { ImagePasteOptions } from './ImagePaste';
import { ImgSizeSpecsOptions } from './ImgSizeSpecs';
import { AddImageAttrs } from './actions';
import { addImageAction } from './const';
export declare type ImgSizeOptions = ImgSizeSpecsOptions & {
    /**
     * If we need to set dimensions for uploaded images
     *
     * @default false
     */
    needToSetDimensionsForUploadedImages?: boolean;
} & Pick<ImagePasteOptions, 'imageUploadHandler' | 'parseInsertedUrlAsImage' | 'enableNewImageSizeCalculation'>;
export declare const ImgSize: ExtensionAuto<ImgSizeOptions>;
declare global {
    namespace WysiwygEditor {
        interface Actions {
            [addImageAction]: Action<AddImageAttrs>;
        }
    }
}
