"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.YfmCutSpecs = exports.cutContentType = exports.cutTitleType = exports.cutType = exports.CutNode = void 0;
const cut_extension_1 = require("@diplodoc/cut-extension");
const const_1 = require("./const");
const parser_1 = require("./parser");
const schema_1 = require("./schema");
const serializer_1 = require("./serializer");
var const_2 = require("./const");
Object.defineProperty(exports, "CutNode", { enumerable: true, get: function () { return const_2.CutNode; } });
Object.defineProperty(exports, "cutType", { enumerable: true, get: function () { return const_2.cutType; } });
Object.defineProperty(exports, "cutTitleType", { enumerable: true, get: function () { return const_2.cutTitleType; } });
Object.defineProperty(exports, "cutContentType", { enumerable: true, get: function () { return const_2.cutContentType; } });
const YfmCutSpecs = (builder, opts) => {
    const schemaSpecs = (0, schema_1.getSchemaSpecs)(opts, builder.context.get('placeholder'));
    builder
        .configureMd((md) => md.use((0, cut_extension_1.transform)({ bundle: false })))
        .addNode(const_1.CutNode.Cut, () => ({
        spec: schemaSpecs[const_1.CutNode.Cut],
        toMd: serializer_1.serializerTokens[const_1.CutNode.Cut],
        fromMd: {
            tokenSpec: parser_1.parserTokens[const_1.CutNode.Cut],
        },
        view: opts.cutView,
    }))
        .addNode(const_1.CutNode.CutTitle, () => ({
        spec: schemaSpecs[const_1.CutNode.CutTitle],
        toMd: serializer_1.serializerTokens[const_1.CutNode.CutTitle],
        fromMd: {
            tokenSpec: parser_1.parserTokens[const_1.CutNode.CutTitle],
        },
        view: opts.cutTitleView,
    }))
        .addNode(const_1.CutNode.CutContent, () => ({
        spec: schemaSpecs[const_1.CutNode.CutContent],
        toMd: serializer_1.serializerTokens[const_1.CutNode.CutContent],
        fromMd: {
            tokenSpec: parser_1.parserTokens[const_1.CutNode.CutContent],
        },
        view: opts.cutContentView,
    }));
};
exports.YfmCutSpecs = YfmCutSpecs;
