"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.yfmTableCellView = exports.yfmTableCellCn = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const icons_1 = require("@gravity-ui/icons");
const uikit_1 = require("@gravity-ui/uikit");
const prosemirror_utils_1 = require("prosemirror-utils");
const classname_1 = require("../../../../../classname");
const core_1 = require("../../../../../core");
const yfm_table_1 = require("../../../../../i18n/yfm-table");
const ErrorBoundary_1 = require("../../../../../react-utils/ErrorBoundary");
const table_utils_1 = require("../../../../../table-utils");
const node_children_1 = require("../../../../../utils/node-children");
const nodes_1 = require("../../../../../utils/nodes");
const ReactRenderer_1 = require("../../../../behavior/ReactRenderer");
const const_1 = require("../../const");
const actions_1 = require("./actions");
exports.yfmTableCellCn = (0, classname_1.cn)('table-cell-view');
const b = exports.yfmTableCellCn;
const Controls = function Controls({ columnNumber, rowNumber, view, getParentTable, isInFirstRow, isFirstInRow, }) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
    const actions = (0, core_1.bindActions)(actions_1.controlActions)(view);
    const controls = [];
    if (isFirstInRow) {
        controls.push(react_1.default.createElement(uikit_1.DropdownMenu, { key: 1, switcherWrapperClassName: b('left-button'), switcher: react_1.default.createElement(uikit_1.Button, { view: 'outlined', size: 's' },
                react_1.default.createElement(uikit_1.Icon, { data: icons_1.EllipsisVertical })), items: [
                {
                    text: (0, yfm_table_1.i18n)('row.add.before'),
                    action: () => {
                        var _a;
                        return actions.appendRow.run({
                            tablePos: (_a = getParentTable()) === null || _a === void 0 ? void 0 : _a.pos,
                            rowNumber,
                            direction: 'before',
                        });
                    },
                    icon: react_1.default.createElement(uikit_1.Icon, { data: icons_1.ArrowUp }),
                    disabled: !actions.appendRow.isEnable({
                        tablePos: (_a = getParentTable()) === null || _a === void 0 ? void 0 : _a.pos,
                        rowNumber,
                        direction: 'before',
                    }),
                },
                {
                    text: (0, yfm_table_1.i18n)('row.add.after'),
                    action: () => {
                        var _a;
                        return actions.appendRow.run({
                            tablePos: (_a = getParentTable()) === null || _a === void 0 ? void 0 : _a.pos,
                            rowNumber,
                            direction: 'after',
                        });
                    },
                    icon: react_1.default.createElement(uikit_1.Icon, { data: icons_1.ArrowDown }),
                    disabled: !actions.appendRow.isEnable({
                        tablePos: (_b = getParentTable()) === null || _b === void 0 ? void 0 : _b.pos,
                        rowNumber,
                        direction: 'after',
                    }),
                },
                {
                    text: (0, yfm_table_1.i18n)('row.remove'),
                    action: () => {
                        var _a;
                        return actions.deleteRow.run({
                            rowNumber,
                            tablePos: (_a = getParentTable()) === null || _a === void 0 ? void 0 : _a.pos,
                        });
                    },
                    icon: react_1.default.createElement(uikit_1.Icon, { data: icons_1.Xmark }),
                    disabled: !actions.deleteRow.isEnable({
                        rowNumber,
                        tablePos: (_c = getParentTable()) === null || _c === void 0 ? void 0 : _c.pos,
                    }),
                },
                {
                    theme: 'danger',
                    text: (0, yfm_table_1.i18n)('table.remove'),
                    action: () => {
                        var _a, _b;
                        return actions.deleteTable.run({
                            tablePos: (_a = getParentTable()) === null || _a === void 0 ? void 0 : _a.pos,
                            tableNode: (_b = getParentTable()) === null || _b === void 0 ? void 0 : _b.node,
                        });
                    },
                    icon: react_1.default.createElement(uikit_1.Icon, { data: icons_1.TrashBin }),
                    disabled: !actions.deleteTable.isEnable({
                        tablePos: (_d = getParentTable()) === null || _d === void 0 ? void 0 : _d.pos,
                        tableNode: (_e = getParentTable()) === null || _e === void 0 ? void 0 : _e.node,
                    }),
                },
            ] }));
    }
    if (isInFirstRow) {
        controls.push(react_1.default.createElement(uikit_1.DropdownMenu, { key: 2, switcherWrapperClassName: b('upper-button'), switcher: react_1.default.createElement(uikit_1.Button, { view: 'outlined', size: 's' },
                react_1.default.createElement(uikit_1.Icon, { data: icons_1.EllipsisVertical })), items: [
                {
                    text: (0, yfm_table_1.i18n)('column.add.before'),
                    action: () => {
                        var _a;
                        return actions.appendColumn.run({
                            tablePos: (_a = getParentTable()) === null || _a === void 0 ? void 0 : _a.pos,
                            columnNumber,
                            direction: 'before',
                        });
                    },
                    icon: react_1.default.createElement(uikit_1.Icon, { data: icons_1.ArrowLeft }),
                    disabled: !actions.appendColumn.isEnable({
                        tablePos: (_f = getParentTable()) === null || _f === void 0 ? void 0 : _f.pos,
                        columnNumber,
                        direction: 'before',
                    }),
                },
                {
                    text: (0, yfm_table_1.i18n)('column.add.after'),
                    action: () => {
                        var _a;
                        return actions.appendColumn.run({
                            tablePos: (_a = getParentTable()) === null || _a === void 0 ? void 0 : _a.pos,
                            columnNumber,
                            direction: 'after',
                        });
                    },
                    icon: react_1.default.createElement(uikit_1.Icon, { data: icons_1.ArrowRight }),
                    disabled: !actions.appendColumn.isEnable({
                        tablePos: (_g = getParentTable()) === null || _g === void 0 ? void 0 : _g.pos,
                        columnNumber,
                        direction: 'after',
                    }),
                },
                {
                    text: (0, yfm_table_1.i18n)('column.remove'),
                    action: () => {
                        var _a;
                        return actions.deleteColumn.run({
                            columnNumber,
                            tablePos: (_a = getParentTable()) === null || _a === void 0 ? void 0 : _a.pos,
                        });
                    },
                    icon: react_1.default.createElement(uikit_1.Icon, { data: icons_1.Xmark }),
                    disabled: !actions.deleteColumn.isEnable({
                        columnNumber,
                        tablePos: (_h = getParentTable()) === null || _h === void 0 ? void 0 : _h.pos,
                    }),
                },
                {
                    theme: 'danger',
                    text: (0, yfm_table_1.i18n)('table.remove'),
                    action: () => {
                        var _a, _b;
                        return actions.deleteTable.run({
                            tablePos: (_a = getParentTable()) === null || _a === void 0 ? void 0 : _a.pos,
                            tableNode: (_b = getParentTable()) === null || _b === void 0 ? void 0 : _b.node,
                        });
                    },
                    icon: react_1.default.createElement(uikit_1.Icon, { data: icons_1.TrashBin }),
                    disabled: !actions.deleteTable.isEnable({
                        tablePos: (_j = getParentTable()) === null || _j === void 0 ? void 0 : _j.pos,
                        tableNode: (_k = getParentTable()) === null || _k === void 0 ? void 0 : _k.node,
                    }),
                },
            ] }));
    }
    return controls.length ? react_1.default.createElement(react_1.default.Fragment, null, controls) : null;
};
const yfmTableCellView = (node, view, getPos) => {
    const getParentTable = () => (0, prosemirror_utils_1.findParentNodeClosestToPos)(view.state.doc.resolve(getPos()), table_utils_1.isTableNode);
    const parentTable = getParentTable();
    const cellCoords = parentTable ? findCellCoords(parentTable.node, node) : null;
    // @ts-expect-error
    if (!cellCoords)
        return {};
    const { cellIndex, rowIndex } = cellCoords;
    const isFirstRow = rowIndex === 0;
    const isFirstColumn = cellIndex === 0;
    if (!isFirstRow && !isFirstColumn) {
        // in this case, we don't need custom nodeView.
        // @ts-expect-error
        return {};
    }
    const dom = document.createElement('td');
    if (node.attrs[const_1.YfmTableAttr.Colspan])
        dom.setAttribute('colspan', node.attrs[const_1.YfmTableAttr.Colspan]);
    if (node.attrs[const_1.YfmTableAttr.Rowspan])
        dom.setAttribute('rowspan', node.attrs[const_1.YfmTableAttr.Rowspan]);
    if (node.attrs[const_1.YfmTableAttr.CellAlign]) {
        dom.classList.add(node.attrs[const_1.YfmTableAttr.CellAlign]);
        dom.setAttribute(const_1.YfmTableAttr.CellAlign, node.attrs[const_1.YfmTableAttr.Rowspan]);
    }
    const contentDOM = document.createElement('div');
    const control = document.createElement('span');
    control.setAttribute('style', 'width: 0; height: 0; float: left;');
    dom.setAttribute('style', 'position: relative; overflow: visible;');
    dom.appendChild(contentDOM);
    dom.appendChild(control);
    const renderItem = (0, ReactRenderer_1.getReactRendererFromState)(view.state).createItem('yfm-table-cell-view', () => (react_1.default.createElement(uikit_1.Portal, { container: control },
        react_1.default.createElement(ErrorBoundary_1.ErrorLoggerBoundary, null,
            react_1.default.createElement(Controls, { columnNumber: cellIndex, rowNumber: rowIndex, isFirstInRow: isFirstColumn, isInFirstRow: isFirstRow, getParentTable: getParentTable, view: view })))));
    return {
        dom,
        contentDOM,
        destroy() {
            renderItem.remove();
        },
        ignoreMutation(mutation) {
            return mutation.type === 'childList' && mutation.target === control;
        },
        update(n) {
            const { rows: nRows, cols: nCols } = (0, table_utils_1.getTableDimensions)(n);
            const { rows, cols } = (0, table_utils_1.getTableDimensions)(node);
            return !(rows !== nRows || cols !== nCols);
        },
    };
};
exports.yfmTableCellView = yfmTableCellView;
function findCellCoords(table, cell) {
    if (!table.lastChild)
        return null;
    const rows = (0, nodes_1.getChildrenOfNode)(table.lastChild); // children of tBody
    for (const row of rows) {
        const node = (0, node_children_1.getChildByNode)(row.node, cell);
        if (node) {
            return {
                rowIndex: row.index,
                cellIndex: node.index,
            };
        }
    }
    return null;
}
