"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.removeRow = void 0;
const prosemirror_model_1 = require("prosemirror-model");
const prosemirror_utils_1 = require("prosemirror-utils");
const __1 = require("..");
const core_1 = require("../../core");
const table_desc_1 = require("../table-desc");
const removeRow = (state, dispatch, _, attrs = {}) => {
    var _a;
    const { tablePos, rowNumber } = attrs;
    if (tablePos === undefined || rowNumber === undefined)
        return false;
    const tableNode = (_a = (0, prosemirror_utils_1.findParentNodeClosestToPos)(state.doc.resolve(tablePos + 1), __1.isTableNode)) === null || _a === void 0 ? void 0 : _a.node;
    if (!tableNode)
        return false;
    const tableDesc = table_desc_1.TableDesc.create(tableNode);
    if (!tableDesc || rowNumber >= tableDesc.rows)
        return false;
    if (!tableDesc.isSafeRow(rowNumber))
        return false;
    if (dispatch) {
        let { from, to } = tableDesc.getRelativePosForRow(rowNumber);
        from += tablePos;
        to += tablePos;
        dispatch((0, core_1.trackTransactionMetrics)(state.tr.replaceWith(from, to, prosemirror_model_1.Fragment.empty), 'removeRow', {
            rows: tableDesc.rows,
            cols: tableDesc.cols,
        }));
    }
    return true;
};
exports.removeRow = removeRow;
