"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.combinedKeyHandler = exports.escapeKeyHandler = exports.enterKeyHandler = void 0;
const shortcuts_1 = require("../shortcuts");
function enterKeyHandler(handler) {
    return (event) => {
        if (event.key === shortcuts_1.Key.Enter) {
            handler(event);
        }
    };
}
exports.enterKeyHandler = enterKeyHandler;
function escapeKeyHandler(handler) {
    return (event) => {
        if (event.key === shortcuts_1.Key.Esc) {
            handler(event);
        }
    };
}
exports.escapeKeyHandler = escapeKeyHandler;
function combinedKeyHandler(handlers) {
    return (event) => {
        const handler = handlers[event.key];
        if (handler) {
            handler(event);
        }
    };
}
exports.combinedKeyHandler = combinedKeyHandler;
