import React, { ComponentType, RefAttributes } from 'react';
import { useMermaid } from '@diplodoc/mermaid-extension/react';
import type { PluginRuntime, TransformMeta } from './types';
export declare type MermaidConfig = Parameters<ReturnType<typeof useMermaid>>[0];
export declare type WithMermaidOptions = {
    runtime: PluginRuntime;
};
export declare type WithMermaidProps = {
    meta: TransformMeta;
    mermaidConfig: MermaidConfig;
};
export declare function withMermaid(opts: WithMermaidOptions): <T extends {
    html: string;
}>(Component: React.ComponentType<T & React.RefAttributes<HTMLDivElement>>) => React.ForwardRefExoticComponent<React.PropsWithoutRef<T & WithMermaidProps> & React.RefAttributes<HTMLDivElement>>;
