import React from 'react';
import { cn } from '../classname';
import { ReactRendererComponent } from '../extensions';
import { logger } from '../logger';
import { useRenderTime } from '../react-utils/hooks';
import { ToolbarView } from './ToolbarView';
import { WysiwygEditorComponent } from './WysiwygEditorComponent';
import './WysiwygEditorView.css';
const b = cn('wysiwyg-editor');
export const WysiwygEditorView = React.memo((props) => {
    const { editor, autofocus, settingsVisible, toolbarVisible, toolbarConfig, hiddenActionsConfig, className, toolbarClassName, children, stickyToolbar = true, } = props;
    useRenderTime((time) => {
        logger.metrics({
            component: 'wysiwyg-editor',
            event: 'render',
            duration: time,
        });
    });
    return (React.createElement("div", { className: b({ toolbar: toolbarVisible }, [className]) },
        toolbarVisible ? (React.createElement(ToolbarView, { editor: editor, editorMode: "wysiwyg", toolbarEditor: editor, stickyToolbar: stickyToolbar, toolbarConfig: toolbarConfig, toolbarFocus: () => editor.focus(), hiddenActionsConfig: hiddenActionsConfig, settingsVisible: settingsVisible, className: b('toolbar', [toolbarClassName]) }, children)) : null,
        React.createElement(WysiwygEditorComponent, { autofocus: autofocus, editor: editor, className: b('editor') },
            React.createElement(ReactRendererComponent, { storage: editor.renderStorage }))));
});
WysiwygEditorView.displayName = 'MarkdownWysiwgEditorView';
