import { CodeEditor } from '../../markup/editor';
import { ToolbarData } from '../../toolbar/Toolbar';
import { ToolbarGroupData } from '../../toolbar/ToolbarGroup';
import { ToolbarListButtonData } from '../../toolbar/ToolbarListButton';
import { ToolbarButtonPopupData, ToolbarItemData, ToolbarListItemData, ToolbarReactComponentData, ToolbarSingleItemData } from '../../toolbar/types';
import type { MarkdownEditorPreset } from '../types';
export declare type MToolbarData = ToolbarData<CodeEditor>;
export declare type MToolbarItemData = ToolbarItemData<CodeEditor>;
export declare type MToolbarSingleItemData = ToolbarSingleItemData<CodeEditor>;
export declare type MToolbarGroupData = ToolbarGroupData<CodeEditor>;
export declare type MToolbarReactComponentData = ToolbarReactComponentData<CodeEditor>;
export declare type MToolbarListButtonData = ToolbarListButtonData<CodeEditor>;
export declare type MToolbarListItemData = ToolbarListItemData<CodeEditor>;
export declare type MToolbarButtonPopupData = ToolbarButtonPopupData<CodeEditor>;
export declare const mHistoryGroupConfig: MToolbarGroupData;
/** Bold, Italic, Underline, Strike buttons group */
export declare const mBoldItemData: MToolbarSingleItemData;
export declare const mItalicItemData: MToolbarSingleItemData;
export declare const mUnderlineItemData: MToolbarSingleItemData;
export declare const mStrikethroughItemData: MToolbarSingleItemData;
export declare const mMonospaceItemData: MToolbarSingleItemData;
export declare const mMarkedItemData: MToolbarSingleItemData;
export declare const mBiusGroupConfig: MToolbarGroupData;
export declare const mHeadingListConfig: MToolbarListButtonData;
export declare const mListsListConfig: MToolbarListButtonData;
export declare const mCheckboxButton: MToolbarSingleItemData;
export declare const mListMoveListConfig: MToolbarListButtonData;
export declare const mLinkButton: MToolbarSingleItemData;
export declare const mNoteButton: MToolbarSingleItemData;
export declare const mQuoteButton: MToolbarSingleItemData;
export declare const mCutButton: MToolbarSingleItemData;
export declare const mTableButton: MToolbarSingleItemData;
export declare const mCodeblockItemData: MToolbarItemData;
export declare const mCodeListConfig: MToolbarListButtonData;
export declare const mMathListConfig: MToolbarListButtonData;
export declare const mMathListItem: MToolbarListItemData;
export declare const mMermaidButton: MToolbarSingleItemData;
export declare const mYfmHtmlBlockButton: MToolbarSingleItemData;
export declare const mImagePopupData: MToolbarButtonPopupData;
export declare const mFilePopupData: MToolbarButtonPopupData;
/** prepared markup toolbar config */
export declare const mToolbarConfig: MToolbarData;
export declare const mHruleItemData: MToolbarSingleItemData;
export declare const mEmojiItemData: MToolbarSingleItemData;
export declare const mTabsItemData: MToolbarSingleItemData;
export declare const mHiddenData: MToolbarSingleItemData[];
export declare const mToolbarConfigByPreset: Record<MarkdownEditorPreset, MToolbarData>;
export declare const mHiddenDataByPreset: Record<MarkdownEditorPreset, MToolbarItemData[]>;
