import { WMermaidNodeView } from './MermaidNodeView';
import { MermaidSpecs } from './MermaidSpecs';
import { MermaidAction } from './MermaidSpecs/const';
import { addMermaid } from './actions';
export const Mermaid = (builder, { loadRuntimeScript }) => {
    builder.use(MermaidSpecs, {
        nodeView: MermaidNodeViewFactory({ loadRuntimeScript }),
    });
    builder.addAction(MermaidAction, () => addMermaid);
};
const MermaidNodeViewFactory = ({ loadRuntimeScript }) => () => (node, view, getPos) => {
    return new WMermaidNodeView(node, view, getPos, { loadRuntimeScript });
};
