import { wrapInList } from 'prosemirror-schema-list';
import { joinPreviousBlock } from '../../../commands/join';
import { findAnyParentList, isListNode, isListOrItemNode } from './utils';
export function toList(listType) {
    return (state, dispatch) => {
        const parentList = findAnyParentList(state.schema)(state.selection);
        if (parentList) {
            if (listType === parentList.node.type)
                return true;
            dispatch === null || dispatch === void 0 ? void 0 : dispatch(state.tr.setNodeMarkup(parentList.pos, listType));
            return true;
        }
        return wrapInList(listType)(state, dispatch);
    };
}
export const joinPrevList = joinPreviousBlock({
    checkPrevNode: isListNode,
    skipNode: isListOrItemNode,
});
