import type { NodeType } from 'prosemirror-model';
import type { ExtensionWithOptions } from '../../../core';
export declare type ListsInputRulesOptions = {
    bulletListInputRule?: false | BulletListInputRuleConfig;
};
export declare const ListsInputRulesExtension: ExtensionWithOptions<ListsInputRulesOptions>;
/**
 * Given a list node type, returns an input rule that turns a number
 * followed by a dot or parenthesis at the start of a textblock into an ordered list.
 */
export declare function orderedListRule(nodeType: NodeType): import("prosemirror-inputrules").InputRule;
declare type BulletListInputRuleConfig = {
    /** @default true */
    dash?: boolean;
    /** @default true */
    plus?: boolean;
    /** @default true */
    asterisk?: boolean;
};
/**
 * Given a list node type, returns an input rule that turns a bullet
 * (dash, plus, or asterisk) at the start of a textblock into a
 * bullet list.
 */
export declare function bulletListRule(nodeType: NodeType, config?: BulletListInputRuleConfig): import("prosemirror-inputrules").InputRule | null;
export {};
