import { AutocompleteAction, AutocompleteHandler } from '../../../behavior/Autocomplete';
export declare type EmojiHandlerParams = {
    defs: Record<string, string>;
    shortcuts?: Partial<Record<string, string | string[]>>;
};
export declare class EmojiHandler implements AutocompleteHandler {
    private readonly _emojis;
    private _emojiCarousel?;
    private _view?;
    private _anchor?;
    private _range?;
    private _popupCloser?;
    private _suggestProps?;
    private _suggestRenderItem?;
    constructor({ defs, shortcuts }: EmojiHandlerParams);
    onOpen(action: AutocompleteAction): boolean;
    onFilter(action: AutocompleteAction): boolean;
    onArrow(action: AutocompleteAction): boolean;
    onEnter(action: AutocompleteAction): boolean;
    onClose(action: AutocompleteAction): boolean;
    onDestroy(): void;
    private closeAutocomplete;
    private select;
    private filterActions;
    private render;
    private onItemClick;
    private updateState;
    private clear;
    private createMenuRenderItem;
    private findAnchor;
}
