import React, { useRef } from 'react';
import { Ellipsis } from '@gravity-ui/icons';
import { Button, Icon, Menu, Popup } from '@gravity-ui/uikit';
import { cn } from '../../../../../classname';
import { i18n as i18nCommon } from '../../../../../i18n/common';
import { useBooleanState } from '../../../../../react-utils/hooks';
import { ImageForm } from './ImageForm';
import './ImgSettingsButton.css';
const b = cn('img-settings-button');
export const ImgSettingsButton = function ({ node, view, updateAttributes, visible, edit, toggleEdit, nodeRef, unsetEdit, onDelete, }) {
    const [popupOpen, setPopupOpen, unsetPopupOpen] = useBooleanState(false);
    const placement = ['bottom-end', 'bottom-start'];
    const buttonRef = useRef(null);
    const handleEdit = () => {
        toggleEdit();
        unsetPopupOpen();
    };
    const isVisibleImageForm = edit;
    const isVisibleEditButton = !edit && (visible || popupOpen);
    const isVisiblePopup = !edit && popupOpen;
    const handleEditButtonClick = (event) => {
        event.preventDefault();
        setPopupOpen();
    };
    return (React.createElement(React.Fragment, null,
        isVisibleImageForm && (React.createElement(ImageForm, { node: node, view: view, updateAttributes: updateAttributes, dom: nodeRef, unsetEdit: unsetEdit })),
        isVisibleEditButton && (React.createElement(Button, { onClick: handleEditButtonClick, ref: buttonRef, size: "s", view: 'raised', className: b() },
            React.createElement(Icon, { data: Ellipsis }))),
        React.createElement(Popup, { open: isVisiblePopup, anchorRef: buttonRef, onClose: unsetPopupOpen, placement: placement },
            React.createElement(Menu, null,
                React.createElement(Menu.Item, { onClick: handleEdit }, i18nCommon('edit')),
                React.createElement(Menu.Item, { onClick: onDelete }, i18nCommon('delete'))))));
};
