import { Blockquote, Bold, Breaks, Code, CodeBlock, Heading, HorizontalRule, Html, Image, Italic, Link, Lists, } from '../extensions/markdown';
import { isFunction } from '../lodash';
import { ZeroPreset } from './zero';
export const CommonMarkPreset = (builder, opts) => {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
    builder.use(ZeroPreset, opts);
    builder
        .use(Html)
        .use(HorizontalRule)
        .use(Code, (_a = opts.code) !== null && _a !== void 0 ? _a : {})
        .use(Bold, (_b = opts.bold) !== null && _b !== void 0 ? _b : {})
        .use(Link, (_c = opts.link) !== null && _c !== void 0 ? _c : {})
        .use(Lists, (_d = opts.lists) !== null && _d !== void 0 ? _d : {})
        .use(Italic, (_e = opts.italic) !== null && _e !== void 0 ? _e : {})
        .use(Breaks, (_f = opts.breaks) !== null && _f !== void 0 ? _f : {})
        .use(CodeBlock, (_g = opts.codeBlock) !== null && _g !== void 0 ? _g : {})
        .use(Blockquote, (_h = opts.blockquote) !== null && _h !== void 0 ? _h : {});
    if (opts.image !== false) {
        builder.use(isFunction(opts.image) ? opts.image : Image, isFunction(opts.image) ? undefined : opts.image);
    }
    if (opts.heading !== false) {
        if (isFunction(opts.heading))
            builder.use(opts.heading);
        else
            builder.use(Heading, (_j = opts.heading) !== null && _j !== void 0 ? _j : {});
    }
};
