import { useEffect } from 'react';
import { useBooleanState } from './hooks';
export const useNodeHovered = (nodeRef) => {
    const [nodeHovered, setNodeHovered, unsetNodeHovered] = useBooleanState(false);
    useEffect(() => {
        const { current: anchor } = nodeRef;
        anchor === null || anchor === void 0 ? void 0 : anchor.addEventListener('mouseenter', setNodeHovered);
        anchor === null || anchor === void 0 ? void 0 : anchor.addEventListener('mouseleave', unsetNodeHovered);
        return () => {
            anchor === null || anchor === void 0 ? void 0 : anchor.removeEventListener('mouseenter', setNodeHovered);
            anchor === null || anchor === void 0 ? void 0 : anchor.removeEventListener('mouseleave', unsetNodeHovered);
        };
        // https://github.com/facebook/react/issues/23392#issuecomment-1055610198
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, [nodeRef.current, setNodeHovered, unsetNodeHovered]);
    return nodeHovered;
};
