export declare type FileUploadResult = {
    url: string;
    /** override file name */
    name?: string;
    /** override file type */
    type?: string;
};
export declare type FileUploadHandler = (file: File) => Promise<FileUploadResult>;
export declare type UploadSuccessItem = {
    file: File;
    result: FileUploadResult;
};
export declare type UploadFailedItem = {
    file: File;
    error: Error;
};
export declare type BatchUploadResult = {
    success: readonly UploadSuccessItem[];
    failed: readonly UploadFailedItem[];
};
export declare function batchUploadFiles(files: readonly File[], handler: FileUploadHandler, onFileUpload?: (item: UploadSuccessItem) => void, onFileFail?: (item: UploadFailedItem) => void): Promise<BatchUploadResult>;
